const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class EnrollmentsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const enrollments = await db.enrollments.create(
      {
        id: data.id || undefined,

        effective_date: data.effective_date || null,
        premium_employee: data.premium_employee || null,
        premium_employer: data.premium_employer || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await enrollments.setEmployee(data.employee || null, {
      transaction,
    });

    await enrollments.setPlan(data.plan || null, {
      transaction,
    });

    await enrollments.setOrganizations(data.organizations || null, {
      transaction,
    });

    return enrollments;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const enrollmentsData = data.map((item, index) => ({
      id: item.id || undefined,

      effective_date: item.effective_date || null,
      premium_employee: item.premium_employee || null,
      premium_employer: item.premium_employer || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const enrollments = await db.enrollments.bulkCreate(enrollmentsData, {
      transaction,
    });

    // For each item created, replace relation files

    return enrollments;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const enrollments = await db.enrollments.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.effective_date !== undefined)
      updatePayload.effective_date = data.effective_date;

    if (data.premium_employee !== undefined)
      updatePayload.premium_employee = data.premium_employee;

    if (data.premium_employer !== undefined)
      updatePayload.premium_employer = data.premium_employer;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await enrollments.update(updatePayload, { transaction });

    if (data.employee !== undefined) {
      await enrollments.setEmployee(
        data.employee,

        { transaction },
      );
    }

    if (data.plan !== undefined) {
      await enrollments.setPlan(
        data.plan,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await enrollments.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return enrollments;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const enrollments = await db.enrollments.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of enrollments) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of enrollments) {
        await record.destroy({ transaction });
      }
    });

    return enrollments;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const enrollments = await db.enrollments.findByPk(id, options);

    await enrollments.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await enrollments.destroy({
      transaction,
    });

    return enrollments;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const enrollments = await db.enrollments.findOne(
      { where },
      { transaction },
    );

    if (!enrollments) {
      return enrollments;
    }

    const output = enrollments.get({ plain: true });

    output.employee = await enrollments.getEmployee({
      transaction,
    });

    output.plan = await enrollments.getPlan({
      transaction,
    });

    output.organizations = await enrollments.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.employees,
        as: 'employee',

        where: filter.employee
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.employee
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  user: {
                    [Op.or]: filter.employee
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.benefit_plans,
        as: 'plan',

        where: filter.plan
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.plan
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  carrier: {
                    [Op.or]: filter.plan
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.effective_dateRange) {
        const [start, end] = filter.effective_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            effective_date: {
              ...where.effective_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            effective_date: {
              ...where.effective_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.premium_employeeRange) {
        const [start, end] = filter.premium_employeeRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            premium_employee: {
              ...where.premium_employee,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            premium_employee: {
              ...where.premium_employee,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.premium_employerRange) {
        const [start, end] = filter.premium_employerRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            premium_employer: {
              ...where.premium_employer,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            premium_employer: {
              ...where.premium_employer,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.enrollments.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('enrollments', 'plan', query),
        ],
      };
    }

    const records = await db.enrollments.findAll({
      attributes: ['id', 'plan'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['plan', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.plan,
    }));
  }
};
